class Rel01 < ActiveRecord::Migration

  def self.up

    create_table "draw_parameters", :force => true do |t|
      t.column "variable_id", :integer, :null => false
      t.column "name", :string, :null => false
      t.column "value", :string, :null => false
    end

    create_table "knowledges", :force => true do |t|
      t.column "title", :string, :null => false
      t.column "textbody", :text, :null => false
      t.column "user_id", :integer, :null => false
      t.column "knowledge_path", :string, :null => false
      t.column "group_id", :integer
    end

    create_table "knowledge_figures", :force => true do |t|
      t.column "knowledge_id", :integer, :null => false
      t.column "variable_id", :integer, :null => false
      t.column "caption", :text, :null => false
    end

    create_table "query_histories", :force => true do |t|
      t.column "args",         :string
      t.column "results",      :string
      t.column "querytype",    :string
      t.column "options",      :string
      t.column "prev",         :integer
      t.column "querypath",    :string
      t.column "user_id",      :integer
      t.column "time",         :datetime
      t.column "tail",         :integer
      t.column "description",  :string
      t.column "path",         :string
    end

  end

  def self.down

    drop_table :draw_parameters
    drop_table :knowledges
    drop_table :knowledge_figures
    drop_table :query_histories

  end
end
